/*
 * console fucker
 * by glen@alkohol.ee, rebane@alkohol.ee
 *
 * Licensed under GPL
 * http://glen.alkohol.ee/cf/
 *
 */

static char *linux_keymap[KEY_MAX - KEY_MIN];

#define get_keystr(key) \
	(key > KEY_MIN && key < KEY_MAX) ? linux_keymap[key - KEY_MIN] : NULL

static void init_keys()
{

	bzero(linux_keymap, sizeof(linux_keymap));

#	define keydefine(key, str) linux_keymap[key - KEY_MIN] = str;

//	keydefine(KEY_BREAK,	"")	// Break key (unreliable) */
	keydefine(KEY_DOWN,		"\033[B")	// Down-arrow */
	keydefine(KEY_UP,		"\033[A")	// Up-arrow */
	keydefine(KEY_LEFT,		"\033[D")	// Left-arrow */
	keydefine(KEY_RIGHT,	"\033[C")	// Right-arrow */
	keydefine(KEY_HOME,		"\033[1~")	// Home key (upward+left arrow) */
	keydefine(KEY_BACKSPACE,"\b")	// Backspace (unreliable) */

	// Function keys. Space for 64 */
	keydefine(KEY_F(1),		"\033[[A")
	keydefine(KEY_F(2),		"\033[[B")
	keydefine(KEY_F(3),		"\033[[C")
	keydefine(KEY_F(4),		"\033[[D")
	keydefine(KEY_F(5),		"\033[[E")
#if 0
	{
		int i;
		for(i =0; i< KEY_MAX - KEY_MIN; i++) {
			printf("%s=%s\r\n",keyname(KEY_MIN+i), linux_keymap[i]);
		}
		exit(1);
	}
#endif
	keydefine(KEY_F(6),		"\033[17~")
	keydefine(KEY_F(7),		"\033[18~")
	keydefine(KEY_F(8),		"\033[19~")
	keydefine(KEY_F(9),		"\033[20~")
	keydefine(KEY_F(10),	"\033[21~")
	keydefine(KEY_F(11),	"\033[23~")
	keydefine(KEY_F(12),	"\033[24~")

//	keydefine(KEY_DL,		"")	// Delete line */
//	keydefine(KEY_IL,		"")	// Insert line */
	keydefine(KEY_DC,		"\033[3~")	// Delete character */
	keydefine(KEY_IC,		"\033[2~")	// Insert char or enter insert mode */
//	keydefine(KEY_EIC,		"")	// Exit insert char mode */
//	keydefine(KEY_CLEAR,	"")	// Clear screen */
//	keydefine(KEY_EOS,		"")	// Clear to end of screen */
//	keydefine(KEY_EOL,		"")	// Clear to end of line */
//	keydefine(KEY_SF,		"")	// Scroll 1 line forward */
//	keydefine(KEY_SR,		"")	// Scroll 1 line backward (reverse) */
	keydefine(KEY_NPAGE,	"\033[6~")	// Next page */
	keydefine(KEY_PPAGE,	"\033[5~")	// Previous page */
//	keydefine(KEY_STAB,		"")	// Set tab */
//	keydefine(KEY_CTAB,		"")	// Clear tab */
//	keydefine(KEY_CATAB,	"")	// Clear all tabs */
//	keydefine(KEY_ENTER,	"")	// Enter or send (unreliable) */
//	keydefine(KEY_SRESET,	"")	// Soft (partial) reset (unreliable) */
//	keydefine(KEY_RESET,	"")	// Reset or hard reset (unreliable) */
//	keydefine(KEY_PRINT,	"")	// Print */
//	keydefine(KEY_LL,		"")	// Home down or bottom (lower left) */
//	keydefine(KEY_A1,		"")	// Upper left of keypad */
//	keydefine(KEY_A3,		"")	// Upper right of keypad */
	keydefine(KEY_B2,		"\033[G")	// Center of keypad */
//	keydefine(KEY_C1,		"")	// Lower left of keypad */
//	keydefine(KEY_C3,		"")	// Lower right of keypad */
//	keydefine(KEY_BTAB,		"")	// Back tab */
//	keydefine(KEY_BEG,		"")	// Beg (beginning) */
//	keydefine(KEY_CANCEL,	"")	// Cancel */
//	keydefine(KEY_CLOSE,	"")	// Close */
//	keydefine(KEY_COMMAND,	"")	// Cmd (command) */
//	keydefine(KEY_COPY,		"")	// Copy */
//	keydefine(KEY_CREATE,	"")	// Create */
	keydefine(KEY_END,		"\033[4~")	// End */
//	keydefine(KEY_EXIT,		"")	// Exit */

	//	same as HOME
	keydefine(KEY_FIND,		"\033[1~")	// Find */
//	keydefine(KEY_HELP,		"")	// Help */
//	keydefine(KEY_MARK,		"")	// Mark */
//	keydefine(KEY_MESSAGE,	"")	// Message */
//	keydefine(KEY_MOVE,		"")	// Move */
//	keydefine(KEY_NEXT,		"")	// Next */
//	keydefine(KEY_OPEN,		"")	// Open */
//	keydefine(KEY_OPTIONS,	"")	// Options */
//	keydefine(KEY_PREVIOUS,	"")	// Prev (previous) */
//	keydefine(KEY_REDO,		"")	// Redo */
//	keydefine(KEY_REFERENCE,"")	// Ref (reference) */
//	keydefine(KEY_REFRESH,	"")	// Refresh */
//	keydefine(KEY_REPLACE,	"")	// Replace */
//	keydefine(KEY_RESTART,	"")	// Restart */
//	keydefine(KEY_RESUME,	"")	// Resume */
//	keydefine(KEY_SAVE,		"")	// Save */
//	keydefine(KEY_SBEG,		"")	// Shifted Beg (beginning) */
//	keydefine(KEY_SCANCEL,	"")	// Shifted Cancel */
//	keydefine(KEY_SCOMMAND,	"")	// Shifted Command */
//	keydefine(KEY_SCOPY,	"")	// Shifted Copy */
//	keydefine(KEY_SCREATE,	"")	// Shifted Create */
//	keydefine(KEY_SDC,		"")	// Shifted Delete char */
//	keydefine(KEY_SDL,		"")	// Shifted Delete line */
	//
	//	same as END
	keydefine(KEY_SELECT,	"\033[4~")	// Select */
//	keydefine(KEY_SEND,		"")	// Shifted End */
//	keydefine(KEY_SEOL,		"")	// Shifted Clear line */
//	keydefine(KEY_SEXIT,	"")	// Shifted Dxit */
//	keydefine(KEY_SFIND,	"")	// Shifted Find */
//	keydefine(KEY_SHELP,	"")	// Shifted Help */
//	keydefine(KEY_SHOME,	"")	// Shifted Home */
//	keydefine(KEY_SIC,		"")	// Shifted Input */
//	keydefine(KEY_SLEFT,	"")	// Shifted Left arrow */
//	keydefine(KEY_SMESSAGE,	"")	// Shifted Message */
//	keydefine(KEY_SMOVE,	"")	// Shifted Move */
//	keydefine(KEY_SNEXT,	"")	// Shifted Next */
//	keydefine(KEY_SOPTIONS,	"")	// Shifted Options */
//	keydefine(KEY_SPREVIOUS,"")	// Shifted Prev */
//	keydefine(KEY_SPRINT,	"")	// Shifted Print */
//	keydefine(KEY_SREDO,	"")	// Shifted Redo */
//	keydefine(KEY_SREPLACE,	"")	// Shifted Replace */
//	keydefine(KEY_SRIGHT,	"")	// Shifted Right arrow */
//	keydefine(KEY_SRSUME,	"")	// Shifted Resume */
//	keydefine(KEY_SSAVE,	"")	// Shifted Save */
//	keydefine(KEY_SSUSPEND,	"")	// Shifted Suspend */
//	keydefine(KEY_SUNDO,	"")	// Shifted Undo */
	keydefine(KEY_SUSPEND,	"\032")	// Suspend */
//	keydefine(KEY_UNDO,		"")	// Undo */
//	keydefine(KEY_MOUSE,	"")	// Mouse event has occurred */
//	keydefine(KEY_RESIZE,	"")	// Terminal resize event */

}
